moSetGetAppSettings = {};
source(MultiOverlayV3.modDir.."app/appIntern.lua");

function moSetGetAppSettings:loadConfig(self, Xml, xmlNameTag, serverApp, file, isSaveGameIndex)
	moSetGetAppSettings.orginalFile = {file, isSaveGameIndex};	
	if MultiOverlayV3.appsFound == nil then MultiOverlayV3.appsFound = {};end;
	local maxApp = 50;	
	for a=1, maxApp do
		local groupNameTag = (xmlNameTag.. ".app(%d)"):format(a-1); --.. tostring(a));
		if groupNameTag == nil or getXMLString(Xml, groupNameTag.. "#source") == nil then break;end;
		local sourceLua = getXMLString(Xml, groupNameTag.. "#source");		
		if sourceLua ~= nil and string.len(sourceLua) > 4 then			
			MultiOverlayV3.appsFound[#MultiOverlayV3.appsFound+1] = {};			
			MultiOverlayV3.appsFound[#MultiOverlayV3.appsFound].sourceLua = sourceLua;			
			MultiOverlayV3.appsFound[#MultiOverlayV3.appsFound].sourceString = string.gsub(sourceLua, ".lua", "");
			MultiOverlayV3.appsFound[#MultiOverlayV3.appsFound].appDir = MultiOverlayV3.appsFound[#MultiOverlayV3.appsFound].sourceString.. "/";				
		elseif sourceLua ~= nil and string.len(sourceLua) > 1 then
			print("!! INFO !! ".. tostring(MultiOverlayV3.metadata.title).. " App Load Error ...not Found Source File at appSettings (app".. tostring(a).. ")")		
		end;
	end;
	local isServer = MultiOverlayV3:getServer()
	moSetGetAppSettings:loadSources(self, serverApp, isServer);
	appIntern:load(self, isServer);		
end;

function moSetGetAppSettings:saveConfig(self, serverApp)
	local file = MultiOverlayV3.settingsDir.. "appSettings.xml";
	if serverApp then file = MultiOverlayV3.detiServerDir.. "appSettings.xml";end;
	local Xml = createXMLFile("MultiOverlayV2_XML", file, "appSettings");
	local xmlNameTag = "appSettings";
	local maxApp = 30;
	if Xml ~= nil then
		for a=1, 1 do
			local groupNameTag = (xmlNameTag.. ".app(%d)"):format(0);
			setXMLString(Xml, groupNameTag.. "#source", "");
			setXMLBool(Xml, groupNameTag.. "#server", false);
			setXMLBool(Xml, groupNameTag.. "#client", true);			
		end;
		saveXMLFile(Xml);
	end;
end;

function moSetGetAppSettings:loadSources(self, serverApp, isServer)
	function sourceLoad(sourceString, sourceLua, appDir)		
		local appFilePath = Utils.getFilename(sourceLua, MultiOverlayV3.appDir.. appDir);		
		if fileExists(appFilePath) then
			source(appFilePath);			
			if MultiOverlayV3[sourceString].loadApp ~= nil then
				MultiOverlayV3[sourceString]:loadApp(self, isServer);
			else
				print("!! INFO !! ".. tostring(MultiOverlayV3.metadata.title).. " App Load Error ...not Found function MultiOverlayV3.".. tostring(sourceString).. ":loadApp() (app ".. tostring(appDir).. ",source- ".. tostring(sourceLua).. " -)")
			end;		
		else			
			print("!! INFO !! ".. tostring(MultiOverlayV3.metadata.title).. " App Load Error ...not Found Source File (app ".. tostring(sourceString).. ", source- ".. MultiOverlayV3.appDir.. tostring(appDir).. tostring(sourceLua).. " -)")			
		end;
	end;
	if #MultiOverlayV3.appsFound > 0 then
		for a=1, #MultiOverlayV3.appsFound do
			if MultiOverlayV3.appsFound[a] ~= nil then
				sourceLoad(MultiOverlayV3.appsFound[a].sourceString, MultiOverlayV3.appsFound[a].sourceLua, MultiOverlayV3.appsFound[a].appDir)
			end;
		end;
	end;	
end;

function moSetGetAppSettings:saveBackup(file, isSaveGameIndex)	
	local fileBackup = MultiOverlayV3.settingsDir.. "appSettingsBackup.xml";		
	if isSaveGameIndex then fileBackup = MultiOverlayV3.saveGameDir.. "appSettingsBackup.xml";end;
	if fileExists(file) then copyFile(file, fileBackup, true);end; --true, replace old file	
end;