moBGAsConfig = {};

function moBGAsConfig:onStartMission()
	moBGAs:load();
end;

function moBGAsConfig:defaultValues()
	moBGAs.values = {bgas={}, updateTimer=5, msec=false};
end;

function moBGAsConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex)
	if moBGAs.values == nil then moBGAsConfig:defaultValues();end;
	local groupNameTag = (xmlNameTag.. ".module.bgas(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		moBGAs.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	end;
	if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		moBGAs.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	end;	
end;

function moBGAsConfig:saveXml(self, Xml, xmlNameTag)
	if moBGAs.values == nil then moBGAsConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.bgas(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", moBGAs.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", moBGAs.values.msec);
	----------------------------------------------------------------------------------------------	
end;

function moBGAsConfig.onSaveCallback()
	moSetGetClientSettings:saveConfig(self);
end;