beehivehouses = {};

--needs beehivehouses (no update)
--lineType 2/beehivehouses
function beehivehouses:load(beehivehouseName)
	local playerFarmId = g_currentMission.player.farmId;
	local lineTable = {lineTyp=2, txtScroll={leftRight=true,upDown=true}};
	if #moModule.beehivehouses ~= nil and #moModule.beehivehouses > 0 then
		local deleteObject = {};
		for index=1, #moModule.beehivehouses do		
			if moModule.beehivehouses[index] ~= nil then
				local beehivehouse = moModule.beehivehouses[index];			
				local isObject = moModule:isObject(beehivehouse.object)
				if isObject and (beehivehouse.object.ownerFarmId == 0 or beehivehouse.object.ownerFarmId == playerFarmId) then
					if beehivehouse.xmlName == beehivehouseName then
						lineTable[#lineTable+1] = {};
						local isLineTable = lineTable[#lineTable];			
						isLineTable.ownValues = {beehivehouseName};
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};			
						isLineTable.txt[1].nodeId = beehivehouse.object.nodeId;
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
						isLineTable.txt[1].bold = true;					
						local isNearObject = moModule:nearPlayerPosition(beehivehouse.object, 10);				
						if isNearObject ~= nil then	isLineTable.txt[1].clickCallback = beehivehouse.returnClickObjectName;end;	
						if isNearObject ~= nil and isNearObject then
							isLineTable.txt[1].txt = ">>".. beehivehouse.name.. "<<";
						else
							isLineTable.txt[1].txt = beehivehouse.name;
						end;
						isLineTable.txt[1].txtPos = 1;					
						---
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];			
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};
						isLineTable.txt[1].width = 70;	--width prozent	
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
						isLineTable.txt[1].bold = moModule.values.txtBold;
						isLineTable.txt[1].txt = moLanguageXml:getTxt("ages", nil, "Age");
						---
						isLineTable.txt[2] = {};
						isLineTable.txt[2].width = 30;	--width prozent	
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor);
						isLineTable.txt[2].bold = moModule.values.txtBold;
						isLineTable.txt[2].txt = tostring(beehivehouse.object.age).. " ".. moLanguageXml:getTxt("ageday", nil, "Day(s)");
						---
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];			
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};
						isLineTable.txt[1].width = 70;	--width prozent	
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
						isLineTable.txt[1].bold = moModule.values.txtBold;
						isLineTable.txt[1].txt = moLanguageXml:getTxt("incomeperhour", nil, g_i18n:getText("shop_income"));
						---
						isLineTable.txt[2] = {};
						isLineTable.txt[2].width = 30;	--width prozent	
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor);
						isLineTable.txt[2].bold = moModule.values.txtBold;
						isLineTable.txt[2].txt = g_i18n:formatMoney(beehivehouse.object.incomePerHour); --moLanguageXml:getTxt("moneysymbol", nil, "€");
					end;
				else	
					table.insert(deleteObject, index);				
				end;		
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.greenhouses, index);
			end;
			moModule:slotOutputCmd(true);
		end;
	end;	
	beehivehouses[beehivehouseName] = {output=lineTable};	
end;

function beehivehouses.returnClickObjectName(...)
	if ... ~= nil then		
		local args = ...;
		if args ~= nil and args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local beehivehouseName = args.ownValues[1];
			if beehivehouses[beehivehouseName] ~= nil and beehivehouses[beehivehouseName].output ~= nil and beehivehouses[beehivehouseName].output[args.line] ~= nil then
				local nodeId = beehivehouses[beehivehouseName].output[args.line].txt[1].nodeId;
				local x, _, z = getWorldTranslation(nodeId);
				moSetGetOverlays:mapHotSpot(nil, x, z);
			end;			
		end;		
	end;
end;

function beehivehouses.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;
		--moModule.active.beehivehouses.isRunning = true;moModule.active.beehivehouses.last = moModule.time.min+moModule.time.delay;
		if args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local beehivehouseName = args.ownValues[1];
			beehivehouses:load(beehivehouseName);
			return beehivehouses[beehivehouseName].output;
		end;
	end;	
end;

function beehivehouses.reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--beehivehouses:load();	
end;

function beehivehouses:generateCmd(beehivehouseName)
	local _, errorTable = 0, {};
	function insertCmd(beehivehouseName)
		local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
		local beehivehouseNameTemp = tostring(beehivehouseName):lower();
		local languageName = moLanguageXml:getTxt(beehivehouseNameTemp, nil, beehivehouseName);
		newCmdTable.cmdTable[1] = {
			cmdName = "beehivehouses_".. tostring(beehivehouseName);
			displayName = moLanguageXml:getTxt("beehivehouses", nil, "Beehivehouses").. " ".. tostring(languageName);		
			multiple = true;
			sortBy = "Beehivehouses";
			infoTxt = "Zeigt alle Bienenhäuser oder diese Category an (".. tostring(languageName).. ")";
			helpTxt = "View Beehivehouses or Category";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			lineTyp = 2;
			typ = "output";
			action = beehivehouses.giveOutputTable; --a function
			ownValues = {beehivehouseName}; 
		};	
		_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);	
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! MultiOverlayV3 Hud -->cmd generate beehivehouses Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
	end;
	if beehivehouseName ~= nil then 
		local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "beehivehouses_".. beehivehouseName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
		if isAlreadyExits == nil then insertCmd(beehivehouseName);end;
	else
		if moModule.beehivehouses ~= nil and #moModule.beehivehouses > 0 then
			for index=1, #moModule.beehivehouses do
				local beehivehouseName = moModule.beehivehouses[index].xmlName;
				local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "beehivehouses_".. beehivehouseName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
				if isAlreadyExits == nil then insertCmd(beehivehouseName);end;
			end;			
		end;
	end;
end;